//На примере устройства, состоящего из одного модуля QMS10, 
//иллюстрируется применения основных библиотечных
//функций и правильная очередность их вызова.

// Пример работает по следующему алгоритму:

//1. Инициализация устройства.
//2. Конфигурация устройства - активизируются пять
//	входных каналов модуля QMS10 с частотой сбора 4 кГц/канал.
//3. Запуск сбора данных
//4. В бесконечном цикле каждые 100 мс идет получение из сервера 
//	обновленных данных, их усреднение и отображение.
//5. По нажатию Esc сбор данных останавливается, выход из программы.


#include "../../dll/qmx.h"
#include <shellapi.h>
#include <stdio.h>
#include <conio.h> 


HANDLE SD;                              // Дескриптор системы
QMX_CONFIG CFG;                         // Конфигурация системы
WORD QMS10Table[16];					// Таблица опроса каналов для QMS10
QMX_CC_F CC_Adc[3];						// Калибровочные коэффициенты

static unsigned int DataPtr, DataPtrOld, CurrentPtr, LengthDataBuf;
static unsigned short int *Data;



static unsigned int QMS_data[8][32], QMS_iter[8][32], time;

void CheckErr(void);
void quit(void);
void DisplayData(void);

//void main(void)
void main(int argc, char* argv[])
{
	char s_wrk[64];
	int i_wrk, mod, ch;

	printf("Please wait....\r");
	
	// Запустим сервер
	ShellExecuteW(NULL, TEXT("open"), TEXT("qmbox_ds.exe"), TEXT("-p3"), NULL, SW_SHOWNORMAL);
	Sleep(500);

	// Получим дискриптор системы
	SD = 0;
	SD=QMX_CircBufAttach(0);
	if (SD == NULL) {
		printf("ERROR: No QMBox found.");
		quit(); 
	}

	// Проинициализуем систему
	QMX_InitModules(SD, QMX_LOG_NONE, NULL);
	CheckErr();

	// Фиктивный вызов QMX_Prepare - выясним конфигурацию устройства
	// т.е. из каких модулей оно состоит
	QMX_MOD_SetActive(SD, 0, QMX_ON);
	QMX_Prepare(SD, 100, &CFG);
	CheckErr();
	QMX_MOD_SetActive(SD, 0, QMX_OFF);
	
	// Убедимся, что в нулевом слоте устройства - модуль QMS10
	strncpy_s (s_wrk, CFG.ModName[0], 10);
	s_wrk[10] = 0;
	if (!_stricmp(s_wrk, "QMS10v1")){
		printf("Module name OK\n");
	}
	else{
		printf("Name error\n");
		quit();
	}
	
	
	// Считаем из ППЗУ модуля колибровочные коэффициенты
	// Для трех входных диапазонов - с усилением 1, 4 и 16
	for (i_wrk=0; i_wrk<3; i_wrk++) QMX_QMS10_ReadCC(SD, 0, i_wrk, &CC_Adc[i_wrk]);

	// Заполним таблицу опроса модуля QMS10:
	// в сеансе сбора данных будут участвовать 5 первых каналов устройства - в дифференциальном режиме
	// с усилениями соответственно 1, 4, 16, 1 и 4
	QMX_QMS10_BuildTableItem(SD, 0, QMX_QMS10_MODE_D, QMX_QMS10_GAIN_1,  &QMS10Table[0]);
	QMX_QMS10_BuildTableItem(SD, 1, QMX_QMS10_MODE_D, QMX_QMS10_GAIN_4,  &QMS10Table[1]);
	QMX_QMS10_BuildTableItem(SD, 2, QMX_QMS10_MODE_D, QMX_QMS10_GAIN_16, &QMS10Table[2]);
	QMX_QMS10_BuildTableItem(SD, 3, QMX_QMS10_MODE_D, QMX_QMS10_GAIN_1,  &QMS10Table[3]);
	QMX_QMS10_BuildTableItem(SD, 4, QMX_QMS10_MODE_D, QMX_QMS10_GAIN_4,  &QMS10Table[4]);

	// Запишем таблицу опроса в модуль
	QMX_QMS10_SetTable(SD, 0, QMS10Table, 5);

	// Установим частоту сбора данных - 20 кГц (4 кГц на канал)
	QMX_QMS10_SetAdcRate(SD, 0, 20000.0, NULL);

	// Подготовимся к сбору данных
	QMX_MOD_SetActive(SD, 0, QMX_ON);
	QMX_Prepare(SD, 100, &CFG);
	CheckErr();
	
	LengthDataBuf = *CFG.CBInput.buf_size;						// размер кольцевого буфера данных, заполняемого сервером
	Data = (unsigned short int*)CFG.CBInput.buf_start;			// указатель на начало кольцевого буфера данных,
																// заполняемого сервером
	DataPtrOld = 0;
	time = 0;

	// Запустим сбор данных
	QMX_Start(SD);
	CheckErr();

	while (!_kbhit()){											// цикл непрерывного сбора данных
																// (до нажатия кнопки клавиатуры)

		DataPtr = *CFG.CBInput.buf_ptr;							//получим значение указателя на последний 
																// полученный элемент данных						
		for (CurrentPtr = DataPtrOld; CurrentPtr != DataPtr; CurrentPtr += 2) { // цикл считывания всех полученных элементов данных
			
			if(CurrentPtr >= *CFG.CBInput.buf_size)				// Проверки, необходимые
				CurrentPtr = 0;									// чтобы текущий указатель 
			if ((!CurrentPtr)&&(!DataPtr))break;				// не перескочил через границу буфера

			mod = (Data[CurrentPtr] >> 5) & 0x07;				// в четном (младшем) 16-ти битном слове элемента данных содержится 
			ch  = Data[CurrentPtr]  & 0x1f;						// информация о номерах канала (младщие 5-ть бит) и модуля (сл. 3-ри бита).
			QMS_data[mod][ch] += Data[CurrentPtr+1];			// в нечетном (старшем) 16-ти битном слове элемента данных содержится
																// в нечетном (старшем) 16-ти битном слове элемента данных содержится
																// информация о величине сигнала измеренного в данном канале данного модуля
																// (в кодах АЦП).
																// в настоящем примере измерения интегрируются в соответствующей ([модуль][канал])
																// ячейке массива накопления. В реальной программе пользователя измерения могут
																// перемещаться в поканальные массивы без усреднения, для дальнейшей обработки или
																// записи в выходные файлы.
			QMS_iter[mod][ch]++;								// счетчик количества суммирований для данного канала
	
		}

		DataPtrOld = DataPtr;						// запоминание предыдущего указателя на последний полученный
													// элемент данных

		time++;										// счетчик количества 100 мс интервалов
		if (time >=5){								// если накопление длится более 0.5 с,
			DisplayData();							// произвести отображение результатов измерений
			time = 0;								// обнуление счетчика количества 100 мс интервалов
		}

		Sleep(100);									// Ожидание следующей порции данных от сервера в течении 100 мс
													// В реальной программе в этом месте вместо Sleep может производится
													// обработка полученных данных и их запись в файл

 }

	quit();											// выход из программы
}


// Выход из программы
void quit(void){
	
	printf("\n\n Please wait....\r");
	QMX_Stop(SD, QMX_STOP_ALL);			// Остановим систему
	QMX_MOD_SetStartMode(SD, 0xFF, QMX_START_MODE_MANUAL); 									

	QMX_CircBufDetach(SD);              // Освободим виртуальный слот USB
										// Остановим сервер
	ShellExecute(NULL, TEXT("open"), TEXT("qmbox_ds.exe"), TEXT("-s0"), NULL, SW_SHOWNORMAL);
	printf("\n\n");
	ExitProcess(0);
}


// Проверка на ошибки
void CheckErr(void) {
char tmp_str[1024];

if (QMX_GetLastError(SD, tmp_str, sizeof(tmp_str))==QMX_OK){ return;}
else  {	printf("%s\n", tmp_str);	quit();}
}


// Отображение данных
void DisplayData(void){

	double d_wrk;

	// вычисление усредненных значений результатов измерений, приведение их к Вольтам при помощи 
	// калибровочных коэффициентов и печать на консоль :
	d_wrk = ((double)QMS_data[0][0]) / ((double)QMS_iter[0][0]) * CC_Adc[0].Scale + CC_Adc[0].Offset;
	printf("%8.4f V ", d_wrk);
	d_wrk = ((double)QMS_data[0][1]) / ((double)QMS_iter[0][1]) * CC_Adc[1].Scale + CC_Adc[1].Offset;
	printf("%8.4f V ", d_wrk);
	d_wrk = ((double)QMS_data[0][2]) / ((double)QMS_iter[0][2]) * CC_Adc[2].Scale + CC_Adc[2].Offset;
	printf("%8.4f V ", d_wrk);
	d_wrk = ((double)QMS_data[0][3]) / ((double)QMS_iter[0][3]) * CC_Adc[0].Scale + CC_Adc[0].Offset;
	printf("%8.4f V ", d_wrk);
	d_wrk = ((double)QMS_data[0][4]) / ((double)QMS_iter[0][4]) * CC_Adc[1].Scale + CC_Adc[1].Offset;
	printf("%8.4f V\r", d_wrk);

	
	// обнуление рабочих ячеек усреднения результатов измерений :
	QMS_data[0][0] = 0; QMS_iter[0][0] = 0; 
	QMS_data[0][1] = 0; QMS_iter[0][1] = 0;
	QMS_data[0][2] = 0; QMS_iter[0][2] = 0;
	QMS_data[0][3] = 0; QMS_iter[0][3] = 0;
	QMS_data[0][4] = 0; QMS_iter[0][4] = 0;
}



